---
title: "Create role"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.sureshake.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Sureshake API › entities

`POST /v2/entities/{id}/roles`

## Path parameters

- `id` (`entity-create-role.path.id`; string, required)
  - format `uuid`

## Request body

_Required._

- `name` (`entity-create-role.name`; string, required)
  - minLength 1
- `description` (`entity-create-role.description`; string, optional, nullable)
- `permissions` (`entity-create-role.permissions`; array<string>, optional)

## Example request

```json
{
  "name": "string",
  "description": "string",
  "permissions": [
    "string"
  ]
}
```

## Code samples

### cURL

```bash
curl --request POST \
  --url 'https://api.sureshake.com/v2/entities/<id>/roles' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "string",
  "description": "string",
  "permissions": [
    "string"
  ]
}
'
```

### TypeScript

```typescript
const url = 'https://api.sureshake.com/v2/entities/<id>/roles';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: JSON.stringify({name: 'string', description: 'string', permissions: ['string']})
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://api.sureshake.com/v2/entities/<id>/roles"

payload = {
    "name": "string",
    "description": "string",
    "permissions": ["string"]
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 200

Default Response

#### Example

```json
{
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "name": "string",
  "description": "string",
  "permissions": [
    "string"
  ]
}
```

- `id` (`entity-create-role.response.200.id`; string, required)
  - format `uuid`
- `name` (`entity-create-role.response.200.name`; string, required)
- `description` (`entity-create-role.response.200.description`; string, required, nullable)
- `permissions` (`entity-create-role.response.200.permissions`; array<string>, required)

### 400

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.400.error`; object, required)
  - `code` (`entity-create-role.response.400.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.400.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.400.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.400.error.traceId`; string, optional) — Unique ID for log correlation

### 401

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.401.error`; object, required)
  - `code` (`entity-create-role.response.401.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.401.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.401.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.401.error.traceId`; string, optional) — Unique ID for log correlation

### 403

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.403.error`; object, required)
  - `code` (`entity-create-role.response.403.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.403.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.403.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.403.error.traceId`; string, optional) — Unique ID for log correlation

### 404

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.404.error`; object, required)
  - `code` (`entity-create-role.response.404.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.404.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.404.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.404.error.traceId`; string, optional) — Unique ID for log correlation

### 409

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.409.error`; object, required)
  - `code` (`entity-create-role.response.409.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.409.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.409.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.409.error.traceId`; string, optional) — Unique ID for log correlation

### 422

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.422.error`; object, required)
  - `code` (`entity-create-role.response.422.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.422.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.422.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.422.error.traceId`; string, optional) — Unique ID for log correlation

### 429

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.429.error`; object, required)
  - `code` (`entity-create-role.response.429.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.429.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.429.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.429.error.traceId`; string, optional) — Unique ID for log correlation

### 500

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.500.error`; object, required)
  - `code` (`entity-create-role.response.500.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.500.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.500.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.500.error.traceId`; string, optional) — Unique ID for log correlation

### 503

Default Response

#### Example

```json
{
  "error": {
    "code": "string",
    "message": "string",
    "details": null,
    "traceId": "string"
  }
}
```

- `error` (`entity-create-role.response.503.error`; object, required)
  - `code` (`entity-create-role.response.503.error.code`; string, required) — Machine-readable error code (e.g., NOT_FOUND)
  - `message` (`entity-create-role.response.503.error.message`; string, required) — Human-readable error message
  - `details` (`entity-create-role.response.503.error.details`; unknown, optional) — Optional structured error details
  - `traceId` (`entity-create-role.response.503.error.traceId`; string, optional) — Unique ID for log correlation


Source: https://docs.sureshake.com/reference/entity-create-role/index.md
